// v1.0 by [SS-12]VeKToR++

echo("ELF Anti-Lag: Performing Presto Version check...");
if ($Presto::version > 0.93) {
	echo("Your current Presto version is greater than 0.93, ELF lag elimination unnecessary.");
} else {

echo("Version check OK. Installing ELF Lag protection.");

// Default Values, for first-time installation
// -------------------------------------------
$FilterTD::UseTeamDamageNotify = false;
$FilterTD::FilterSpeed = 2;
$FilterTD::NotifyFrequency = 10;
// -------------------------------------------

include("presto\\event.cs");
include("presto\\events.cs");
include("Writer\\event.cs");
include("Writer\\events.cs");
include("vektor\\TDNotify.cs");
if (isfile("config\\TDFilterPrefs.cs")) include("TDFilterPrefs.cs");

function onClientMessage(%client, %msg)
{
   if(%client)
      $lastClientMessage = %client;
   else {
      if (((%type = Match::String(%msg, "You just harmed Teammate *")) || (Match::String(%msg, "You took Friendly Fire from *"))) && (string::findsubstr(%msg, "with your mine!") == -1)) {
         if (($FilterTD::HideTD) || ($FilterTD::FilterSpeed > 10))
            return false;

         $FilterTD::HideTD = true;
         schedule("$FilterTD::HideTD = false;", $FilterTD::FilterSpeed);
         
         if (%type)
         	event::Trigger(eventHarmTeammate, Match::result(0));
         else
         	event::Trigger(eventFriendlyFire, Match::result(0));
         	
	 return true;
      }
   }

   // Chop off the extended tags.
   %idx = String::FindSubStr(%msg, "~");
   if (%idx != -1) {
	%text = String::GetSubStr(%msg, %idx+1, 10000);
	%short = String::GetSubStr(%msg, 0, %idx);

	while (%text != "") {
		if (String::GetSubStr(%text, 0,1) == "w")
			break;
		%idx = String::FindSubStr(%text, "~");
		if (%idx == -1) {
			%str = %text;
			%text = "";
			}
		else	{
			%str = String::GetSubStr(%text, 0,%idx);
			%text = String::GetSubStr(%text, %idx+1, 10000);
			}

		%idx = String::FindSubStr(%str, ":");
		if (%idx == -1)
			Event::Trigger(eventClientTagMessage, %client, %str);
		else	Event::Trigger(eventClientTagMessage, %client,
					   String::GetSubStr(%str, 0,%idx),
					   String::GetSubStr(%str, %idx+1, 10000));
		}
	}
   else %short = %msg;

   %returnsExtended = Event::Trigger(eventExtendedClientMessage, %client, %msg, %short);
   %returns = Event::Trigger(eventClientMessage, %client, %short);
   if (Event::Returned(%returns, mute) || Event::Returned(%returnsExtended, mute))
	return false;
   return true;
}

function TDFilter::SetFrequency() {
	$FilterTD::FilterSpeed = control::Getvalue("TDFilter::MsgSlider") + 1;
	if ($FilterTD::FilterSpeed < 11)
		control::setvalue("TDFilter::FrequencyText", "1 msg per " @ $FilterTD::FilterSpeed @ " sec");
	else
		control::setvalue("TDFilter::FrequencyText", "mute all.");
}

function TDFilter::SetResponse() {
	$FilterTD::NotifyFrequency = control::getvalue("TDFilter::ResponseSlider") + 1;
	control::setvalue("TDFilter::ResponseTXT", "1 msg per " @ $FilterTD::NotifyFrequency @ " sec");
}

function TDFilter::EnableCheck() {
	control::setvalue("TDFilter::Enable", $FilterTD::UseTeamDamageNotify = true);

	control::setactive("TDFilter::ResponseSlider", $FilterTD::UseTeamDamageNotify);
	control::setactive("TDFilter::BindKey1", $FilterTD::UseTeamDamageNotify);
}

function TDFilter::EnableUnCheck() {
	control::setvalue("TDFilter::Enable", $FilterTD::UseTeamDamageNotify = false);

	control::setactive("TDFilter::ResponseSlider", $FilterTD::UseTeamDamageNotify);
	control::setactive("TDFilter::BindKey1", $FilterTD::UseTeamDamageNotify);
}

function TDFilter::OnOpen() {
	control::setvalue("TDFilter::MsgSlider", $FilterTD::FilterSpeed - 1);
	if ($FilterTD::FilterSpeed < 11)
		control::setvalue("TDFilter::FrequencyText", "1 msg per " @ $FilterTD::FilterSpeed @ " sec");
	else
		control::setvalue("TDFilter::FrequencyText", "mute all.");

	control::setvalue("TDFilter::ResponseSlider", $FilterTD::NotifyFrequency);
	control::setvalue("TDFilter::ResponseTXT", "1 msg per " @ $FilterTD::NotifyFrequency @ " sec");

	control::setvalue("TDFilter::Enable", $FilterTD::UseTeamDamageNotify);

	control::setactive("TDFilter::ResponseSlider", $FilterTD::UseTeamDamageNotify);
	control::setactive("TDFilter::BindKey1", $FilterTD::UseTeamDamageNotify);
	
}

function TDFilter::OnClose() {
	export("$FilterTD::FilterSpeed", "config\\TDFilterPrefs.cs", false);
	export("$FilterTD::NotifyFrequency", "config\\TDFilterPrefs.cs", true);
	export("$FilterTD::UseTeamDamageNotify", "config\\TDFilterPrefs.cs", true);	
}
event::attach(eventExit, "TDFilter::OnClose();");

NewOpts::Register("ELF Lag / TeamDamage options", "config\\vektor\\gui\\TDFilter.gui", "TDFilter::OnOpen();", "TDFilter::OnClose();", TRUE);

}

// help section
%header = "Max Team Damage Msg Frequency";
%text = "This slider lets you choose the maximum number of team damage messages that will occur in a given interval of time. For example, if you set it to \"1 per 3 sec\", you will only see a maximum one team damage message every 3 seconds. Turn it all the way to the right to mute team damage messages altogether";
NewOpts::RegisterHelp("ELF Lag / TeamDamage options", %header, %text);

%header = "Enable Team Damage Response";
%text = "Check this box to enable this script's internal team-damage automessaging (notifies teammates about damaging yoy / taking damage from you)";
NewOpts::RegisterHelp("ELF Lag / TeamDamage options", %header, %text);

%header = "Max Team Damage Response Frequency";
%text = "This slider controls the minimum amount of time between team-damage notification calls. For example, if you set it to \"1 per 10 sec\", you would send team damage notify messages a maximum of one every 10 seconds (only enabled if Team Damage notify is ON)";
NewOpts::RegisterHelp("ELF Lag / TeamDamage options", %header, %text);

%header = "TeamDamage Notify Ingame Toggle";
%text = "This key lets you toggle Team Damage notification on and off ingame.";
NewOpts::RegisterHelp("ELF Lag / TeamDamage options", %header, %text);
